import { html, repeat, when } from '@microsoft/fast-element';
/**
 * @public
 */
export const FoundationAlertsTemplate = html `
  <section class="wrapper">
    ${when((x) => x.displayState === 'add', html `
        <foundation-form
          resourceName="EVENT_DYNAMIC_RULE_NOTIFY_CREATE"
          @submit-success=${(x) => () => (x.displayState = 'list')}
        ></foundation-form>
      `)}
    ${when((x) => x.displayState === 'edit', html `
        <foundation-form
          resourceName="EVENT_DYNAMIC_RULE_NOTIFY_UPDATE"
          :data=${(x) => x.alertEditItemData}
          @submit-success=${(x) => (x.displayState = 'list')}
        ></foundation-form>
      `)}
    ${when((x) => x.displayState === 'list', html `
        <div class="header">
          <h2 class="title" part="title">Alerts rules</h2>
          <nav class="main-menu">
            <zero-button
              class="main-button"
              @click=${(x) => x.handleAddAlertAction()}
              part="add-button"
            >
              <zero-icon name="plus" size="1x"></zero-icon>
            </zero-button>
            <zero-dropdown-menu
              class="main-button filter-button"
              name=""
              :items=${(x) => x.filters}
              part="filter-button"
            />
              <zero-icon name="filter" size="1x"></zero-icon>
            </zero-dropdown-menu>
          </nav>
        </div>
        ${when((x) => { var _a; return ((_a = x.items) === null || _a === void 0 ? void 0 : _a.length) >= 1; }, html `
            <ul class="list" part="list">
              ${repeat((x) => x.items, html `
                  <li class="item" part="item">
                    <h4 class="item-title">${(x) => x.RULE_EXPRESSION}</h4>
                    <div class="item-bottom">
                      <span class="status ${(x) => x.RULE_STATUS.toLowerCase()}">
                        ${(x, c) => c.parent.statusLabelMap[x.RULE_STATUS]}
                      </span>
                      <span class="date">${(x) => x.DATE}</span>
                      <nav class="item-menu">
                        <zero-button
                          class="button"
                          @click=${(x, c) => c.parent.handleEditAlertAction(x)}
                        >
                          <zero-icon name="gear"></zero-icon>
                        </zero-button>
                        <zero-button class="button" @click=${(x, c) => c.parent.toogleStatus(x)}>
                          <zero-icon name="grip-lines-vertical"></zero-icon>
                        </zero-button>
                        <zero-button
                          class="button"
                          @click=${(x, c) => c.parent.delete(x.DYNAMIC_NOTIFY_RULE_ID)}
                        >
                          <zero-icon name="trash"></zero-icon>
                        </zero-button>
                      </nav>
                    </div>
                  </li>
                `)}
            </ul>
          `)}
        ${when((x) => { var _a; return ((_a = x.items) === null || _a === void 0 ? void 0 : _a.length) === 0; }, html `
            <p class="empty" part="empty">No alerts</p>
          `)}
      `)}
  </section>
`;
