import { Connect } from '@genesislcap/foundation-comms';
import { Datasource } from '@genesislcap/foundation-comms';
import { ElementStyles } from '@microsoft/fast-element';
import { FASTElement } from '@microsoft/fast-element';
import { Message } from '@genesislcap/foundation-comms';
import { Subscription } from 'rxjs';
import { ViewTemplate } from '@microsoft/fast-element';

declare interface AlertRule extends AlertRuleRow {
    DATE: string;
}

declare interface AlertRuleRow {
    DYNAMIC_NOTIFY_RULE_ID: string;
    MESSAGE: string;
    RULE_DESCRIPTION: string;
    RULE_EXPRESSION: string;
    RULE_NAME: string;
    RULE_STATUS: AlertRuleStatus;
    RULE_TABLE: string;
    TOPIC: string;
    USER_NAME: string;
    ROW_REF: string;
}

declare enum AlertRuleStatus {
    ENABLED = "ENABLED",
    DISABLED = "DISABLED"
}

declare type displayState = 'add' | 'edit' | 'list';

/**
 * Foundation alerts component for handle alerts rules list
 * Allow creating, disabling and deleting alerts
 * @beta
 */
export declare class FoundationAlerts extends FASTElement {
    connect: Connect;
    datasource: Datasource;
    displayState: displayState;
    items: AlertRule[];
    alertEditItemData: AlertRule;
    private sourceRef;
    private resourceName;
    private statusLabelMap;
    dataSubscription: Subscription;
    ready: boolean;
    filters: {
        name: string;
        callback: () => void;
        icon: {
            name: string;
        };
    }[];
    criteriaFromFilters: Map<string, string>;
    criteriaFromFiltersChanged(): void;
    connectedCallback(): Promise<void>;
    private findIndexAlertByRef;
    private fetchData;
    private handleStreamUpdate;
    private handleInserts;
    private handleDeletes;
    private handleUpdates;
    private buildCriteria;
    private setFilter;
    private removeFilter;
    delete(id: AlertRuleRow['DYNAMIC_NOTIFY_RULE_ID']): Promise<Message>;
    toogleStatus({ RULE_STATUS, DYNAMIC_NOTIFY_RULE_ID: ID, }: AlertRuleRow): Promise<Message>;
    handleAddAlertAction(): void;
    handleEditAlertAction(item: any): void;
}

/**
 * @public
 */
export declare const FoundationAlertsStyles: ElementStyles;

/**
 * @public
 */
export declare const FoundationAlertsTemplate: ViewTemplate<FoundationAlerts, any>;

export { }
